/*
 * Creature - Tim Tyler 2000-2000.
 */

   public class Creature extends Object {
      Entity[] entity_list;
   
      int max_number_of_entities;
      int number_of_entities;
      int status;
   
      char age_of_creature;
      char age_of_puberty;
      char period_of_gestation;
      char age_when_next_fertile;
      char maximum_age;
   
      boolean egg;
      boolean egg_attached;
      boolean fission;
   
      // boolean reproducing;
   
      byte number_of_kids_so_far;
   
      Entity read_entity;
      Entity write_entity;
   
      Link read_link;
      Link write_link;
   
      PrivateWorld private_world; // needed?
   
      Genome genome;
   
      Creature next_creature;   // used for reproduction...
      PairManager pair_manager; // links between the corresponding cells of this creature and the next...
   
      int stored_colour;
      int stored_elasticity;
      Link stored_link;
      Link old_write_link;
   
      // static variables...
      static int temp;
      static int temp2;
      static int temp3;
      static int temp4;
   
      static int instruction;
   
      static Entity[] new_entity_list;
   
      static Entity temp_entity;
      static Entity next_entity;
      static Entity corresponding_entity;
      static Entity other_temp_entity;
      static Entity other_corresponding_entity;
   	// static Entity expected_entity;
   
      static Creature temp_creature;
      static CreatureManager temp_creature_manager;
   
      static Link temp_link;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      final static int DEAD = 1 << 31;
   
      Creature() {
         max_number_of_entities = 1;
         entity_list = new Entity[max_number_of_entities];
         genome = new Genome();
      
         reset();
      }
   
   
      final void reset() {
         number_of_entities = 0;
         status = 0;
      
         number_of_kids_so_far = 0;
         age_of_creature = 0;
         age_of_puberty = (char)(64 + rnd.nextInt(32));
         period_of_gestation = 64;
         age_when_next_fertile = age_of_puberty;
         maximum_age = (char)(128 + rnd.nextInt(128));
      
         genome.reset();
      
         egg = false;
         egg_attached = false;
         fission = false;
      }
   
   
      final void add(Entity e) {
         if (number_of_entities >= max_number_of_entities) {
            makeMoreEntities();
         }
      
         entity_list[number_of_entities++] = e;
      
         e.creature = this;
      }
   
   
     // again, this is wasteful :-|
      final void makeMoreEntities() {
         max_number_of_entities++;
      
         new_entity_list = new Entity[max_number_of_entities];
      
         for (temp = 0; temp < (max_number_of_entities - 1); temp++) {
            new_entity_list[temp] = entity_list[temp];
         }
      
         entity_list = new_entity_list;
      }
   
   
     // returns number within this creature...
      final int getEntityNumber(Entity e) {
         for (temp = 0; temp < number_of_entities; temp++) {
            if (entity_list[temp] == e) {
               return temp;
            }
         }
      
         // debug("Entity is not part of this creature"); 
      
         return -1;
      }
   
   
   	 // returns number within this creature...
   
      final boolean isAssociatedWithThisCreature(Entity e) {
         for (temp = 0; temp < number_of_entities; temp++) {
            if (entity_list[temp] == e) {
               return true;
            }
         }
      
         return false;
      }
   
   
      final void markAsKilled() {
         status |= Creature.DEAD;
         // need to manually go through and destroy all references to this creature...
         for (temp = 0; temp < number_of_entities; temp++) {
            entity_list[temp].creature = null; // OK after all...
         }
      }
   
   
      final void beginToReproduce() {
         if (next_creature == null) {
            next_creature = new Creature();
         }
         else
         {
            next_creature.reset();
         }
      
         next_creature.mostlyCopy(this);
      
         if (pair_manager == null) {
            pair_manager = new PairManager(); // links between the corresponding cells of this creature and the next...
         }
         else
         {
            pair_manager.reset();
         }
      
         genome.executing = true;
      }
   
   
      final void executeInstruction() {
         if (genome.executing) {
            instruction = genome.genome[genome.genome_index++];
            if (genome.genome_index >= genome.genome_size) {
               genome.finishExecution();
            }
         
            switch (instruction) {
               case Genome.COPY:
                  temp_entity = private_world.addNewAgent(read_entity);
                  temp_entity.setInitialSize((byte)4,read_entity.target_diameter);
                  temp_entity.creature = this;
               
                  next_entity = write_link.theOtherEnd(write_entity);
                  old_write_link = write_link;
               
                  temp_entity.x = (next_entity.x + write_entity.x) >> 1; // NPE??
                  temp_entity.y = (next_entity.y + write_entity.y) >> 1;
               
                  temp_link = private_world.link_manager.setLink(write_entity, temp_entity, write_link);
                  temp_link.setInitialLength(write_link.lower_length_limit >> 1, write_link.target_length);
                  private_world.link_manager.setLink(read_entity, temp_entity, 256, 5, 0, 0); // ;-)
               
                  write_link = temp_link; // ?
               
                  temp_link = private_world.link_manager.setLink(temp_entity, next_entity, read_link);
                  temp_link.setInitialLength(write_link.lower_length_limit >> 1, read_link.target_length);
               
                  write_link = temp_link; // ?
               
                  if (genome.genome_index > 1) {
                     private_world.link_manager.deleteAllLinksBetween(write_entity, next_entity);
                  }
                  else
                  {
                     // stored_link = old_write_link; // private_world.link_manager.linkBetween(write_entity, next_entity);
                     //stored_elasticity = stored_link.elasticity;
                     //stored_colour = stored_link.colour;
                     // stored_link.elasticity = 0;
                     //stored_link.colour = 0;
                  }
               
               	// add entity to creature...? (no...)..?!?!?
               	// Update "List of Links"...
               	// add entity to new creature...
                  next_creature.add(temp_entity);
               
                  // old, new
                  pair_manager.add(read_entity,temp_entity);
               
                  break;
            
               case Genome.FOLLOW:
                  read_entity  = read_link.theOtherEnd(read_entity);
                  read_link    = read_entity.list_of_links.link[0];
               
                  break;
            
               case Genome.FINISH:
                  //if (stored_link != null) {
                     //stored_link.elasticity = stored_elasticity;
                     //stored_link.colour = stored_colour;
                  //}
               
               	// break all links between the creatures...
                  for (temp3 = 0; temp3 < next_creature.number_of_entities; temp3++) {
                     temp_entity = next_creature.entity_list[temp3];
                     private_world.link_manager.killAllLinks(temp_entity);
                  }
               
                  // reconstruct new links, using the old ones as a template...
                  for (temp3 = 0; temp3 < number_of_entities; temp3++) {
                     temp_entity = entity_list[temp3];
                     corresponding_entity = pair_manager.findCorrespondingEntity(temp_entity);
                     corresponding_entity.creature = next_creature;
                     temp4 = temp_entity.list_of_links.number_of_links;
                     for (temp2 = 0; temp2 < temp4; temp2++) {
                        temp_link = temp_entity.list_of_links.link[temp2];
                        other_temp_entity = temp_link.theOtherEnd(temp_entity);
                        if (isAssociatedWithThisCreature(other_temp_entity)) {
                           other_corresponding_entity = pair_manager.findCorrespondingEntity(other_temp_entity);
                           if (other_corresponding_entity != null) { // needed?
                              if (!private_world.link_manager.aLinkLikeThisExists(corresponding_entity, other_corresponding_entity)) {
                                 temp_link = private_world.link_manager.setLink(corresponding_entity, other_corresponding_entity, temp_link);
                                 temp = private_world.distanceBetween(corresponding_entity, other_corresponding_entity);
                                 temp_link.setInitialLength(temp, temp_link.target_length);
                              }
                           }
                        }
                     }
                  }
               
                  // Make sure the order of the links in the new entity's list of links is
                  // the same as it was for the old entity...
                  for (temp3 = 0; temp3 < number_of_entities; temp3++) {
                     temp_entity = entity_list[temp3];
                     corresponding_entity = pair_manager.findCorrespondingEntity(temp_entity);
                     temp_link = temp_entity.list_of_links.link[0];
                     other_temp_entity = temp_link.theOtherEnd(temp_entity);
                  
                     other_corresponding_entity = pair_manager.findCorrespondingEntity(other_temp_entity);
                     temp_link = corresponding_entity.list_of_links.link[0];
                     if (other_corresponding_entity != temp_link.theOtherEnd(corresponding_entity)) {
                        temp4 = corresponding_entity.list_of_links.number_of_links;
                        for (temp2 = 1; temp2 < temp4; temp2++) {
                           temp_link = corresponding_entity.list_of_links.link[temp2];
                           if (other_corresponding_entity == temp_link.theOtherEnd(corresponding_entity)) {
                              corresponding_entity.list_of_links.link[temp2] = corresponding_entity.list_of_links.link[0];
                              corresponding_entity.list_of_links.link[0] = temp_link;
                           
                              break;
                           }
                        }
                     }
                  }
               
                  read_entity = genome.initial_read_entity;
                  write_entity = genome.initial_write_entity;
                  setDefaultRWLinks();
               
                  next_creature.read_entity = pair_manager.findCorrespondingEntity(read_entity);
                  next_creature.write_entity = pair_manager.findCorrespondingEntity(write_entity);
               
                  next_creature.genome.initial_read_entity = next_creature.read_entity;
                  next_creature.genome.initial_write_entity = next_creature.write_entity;
                  next_creature.setDefaultRWLinks();
               
                  temp_creature_manager = private_world.creature_manager;
                  temp_creature_manager.add();
                  temp_creature = temp_creature_manager.creature[temp_creature_manager.number_of_creatures - 1];
                  temp_creature_manager.creature[temp_creature_manager.number_of_creatures - 1] = next_creature;
                  next_creature = temp_creature;
               
               
               
                  genome.finishExecution();
               
                  break;
            }
         }
      }
   
   
      final void setDefaultRWLinks() {
         read_link = read_entity.list_of_links.link[0];
         write_link = write_entity.list_of_links.link[0];
      }
   
   
      final void mostlyCopy(Creature c) {
         egg = c.egg;
         egg_attached = c.egg_attached;
         fission = c.fission;
      
         genome.copy(c.genome);
         private_world = c.private_world;
      }
   
   
      final void debug(String o) {
         System.out.println(o);
      }
   }
