/*
 * EntityManager Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class EntityManager extends PrivateWorld {
      static EntityList list;
   
      Entity_Leader[] new_array_of_leaders;
      Entity_Leader[] leader;
   
      EntityGrid entity_grid;
   
      // static stuff...
      static int shift = Entity.shift;
   
      static int temp_detection_distance;
      static int temp_detection_distance2;
      static int temp_detection_distance_squared;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      static int magnitude;
      static int minimum_magnitude;
      static int maximum_magnitude = 1 << 24;
   
      static int gcd;
      static int piston = 1000;
   
      static int new_bin_x;
      static int new_bin_y;
   
      static Entity_Leader temp_leader;
   
      static int target_number_of_agents = 600;
   
      static int target_number_of_leaders = 1;
      static int number_of_leaders    = 0;
   
      static int max_number_of_links = 10;
      static int number_of_links = 1;
   
      static int towards_leader;
      static int acc_of_leader;
      static int gravity;
   
      static byte general_eggsize;
      static byte general_size;
   
      static int number_of_ship;
   
      static Ships ship;
   
      EntityManager() {
         super();
      }
   
   
      final public void initial_reset() {
         max_number_of_agents = 1;
         number_of_agents = 0;
      
         number_of_leaders = 0;
      
         Entity.initial();
      
         agent = new Entity[max_number_of_agents];
         leader = new Entity_Leader[number_of_leaders];
      }
   
   
      final public void initial() {
         set(null);
         initial_reset();
      
         // link_manager = new LinkManager();
      
         if (Shoals.gas_sim) {
            target_number_of_agents = 600;
            target_number_of_leaders = 1;
            towards_leader = 0x0; // << shift;
            acc_of_leader = 0x0;
            gravity = 0;
            minimum_magnitude = 30 << 6;
            general_eggsize = 30;
            general_size = 14;
            Entity.max_velocity = 50 << 5;	
            Entity.friction_strength = 5;
         }   	
         else
         {
            target_number_of_leaders = 1;
            towards_leader = 200 << 8;
            acc_of_leader = 50;
            general_eggsize = 48;
            general_size = 30;
            gravity = 0;
            minimum_magnitude = 30 << 6;
            Entity.max_velocity = 500 << 5;
            Entity.friction_strength = 10;
         }
      
         if (Shoals.initial_type != Shoals._MIXTURE) {
            Shoals_Input.loadFromString(getCreatureDescription(Shoals.initial_type),Shoals.entity_manager,0,0,160);
         
            Shoals_Input.addFromString(getCreatureDescription(Shoals.initial_type),Shoals.entity_manager,200 << shift,200 << shift,192);
         
            Shoals_Input.addFromString(getCreatureDescription(Shoals.initial_type),Shoals.entity_manager,400 << shift,400 << shift,256);
         }
         else
         {
            Shoals_Input.loadFromString(getCreatureDescription(Shoals._AMOEBA),Shoals.entity_manager,500 << shift,0 << shift, 160);
            // Shoals_Input.addFromString(getCreatureDescription(Shoals._SMALLAMOEBA),Shoals.entity_manager,0 << shift, 0 << shift, 160);
            Shoals_Input.addFromString(getCreatureDescription(Shoals._SPERM),Shoals.entity_manager,150 << shift, 100 << shift,192);
            //Shoals_Input.addFromString(getCreatureDescription(Shoals._TADPOLES),Shoals.entity_manager,300 << shift, 200 << shift,256);
            Shoals_Input.addFromString(getCreatureDescription(Shoals._WORMS),Shoals.entity_manager,600 << shift, 300 << shift,256);
         }
         number_of_leaders = 1;
      
         leader = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            leader[temp] = new Entity_Leader(rnd.nextInt(Shoals_Canvas.gsx) << shift,rnd.nextInt(Shoals_Canvas.gsy) << shift, rnd.nextInt());
            leader[temp].status |= Entity.IMMORTAL | Entity.IMMUNE;
         }
      
         addNewAgent(100, 100, (char)79, (byte)16, (byte)14, Entity.DEADLY | Entity.IMMORTAL | Entity.DRAG | Entity.ALWAYS_CIRCULAR);
      }
   
   
      final public String getCreatureDescription(int _type) {
         switch (_type) {
            case Shoals._BOGGLERS:
               return "Creature Key_Node:0 Egg Egg_attached Agent X:21337 Y:121899 D:9 C:133 Status:268435456 Write_point Agent X:15564 Y:62210 D:30 C:55 Agent X:22187 Y:96799 D:21 C:58 Agent X:21959 Y:75481 D:30 C:56 Agent X:27660 Y:35877 D:56 Status:1677721600 Agent X:21735 Y:116035 D:14 C:60 Agent X:22588 Y:86543 D:25 C:57 Agent X:22322 Y:108370 D:14 C:59 Agent X:14721 Y:48691 D:30 C:435 Agent X:8828 Y:35305 D:56 Status:1677721600 Agent X:23506 Y:48237 D:30 C:435 Agent X:24802 Y:64249 D:30 C:55 Link One:8 Two:10 ULL:45 E:200 C:0 Link One:1 Two:11 ULL:45 E:200 C:0 Link One:4 Two:8 ULL:74 E:200 C:0 Link One:7 Two:2 ULL:28 E:200 C:508 Link One:6 Two:3 ULL:35 E:200 C:508 Link One:0 Two:4 ULL:290 E:10 C:0 Link One:8 Two:11 ULL:49 E:200 C:0 Link One:10 Two:4 ULL:50 E:200 C:510 Link One:1 Two:10 ULL:47 E:200 C:0 Link One:8 Two:9 ULL:53 E:200 C:510 Link One:3 Two:11 ULL:45 E:200 C:508 Link One:1 Two:8 ULL:64 E:200 C:508 Link One:9 Two:4 ULL:70 E:200 C:0 Link One:2 Two:6 ULL:30 E:200 C:508 Link One:3 Two:1 ULL:52 E:200 C:508 Link One:7 Two:5 ULL:24 E:200 C:508 Link One:0 Two:9 ULL:290 E:10 C:0 Link One:9 Two:10 ULL:76 E:200 C:0 Link One:5 Two:0 ULL:20 E:200 C:508 Link One:11 Two:10 ULL:68 E:200 C:508 ";
            
            case Shoals._AMOEBA:
               return "Creature Key_Node:0 Data: 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 999 Fission Agent X:7940 Y:22632 D:47 C:400 Agent X:6372 Y:39392 D:47 C:402 Agent X:13045 Y:8722 D:47 C:404 Read_point Agent X:28221 Y:9584 D:47 C:408 Agent X:19643 Y:48771 D:47 C:410 Write_point Agent X:39769 Y:17585 D:47 C:412 Agent X:42406 Y:31205 D:47 C:414 Agent X:35675 Y:45874 D:47 C:416 Link One:0 Two:1 ULL:60 E:200 C:255 Link One:1 Two:4 ULL:60 E:200 C:255 Link One:4 Two:7 ULL:60 E:200 C:255 Link One:7 Two:6 ULL:60 E:200 C:255 Link One:6 Two:5 ULL:60 E:200 C:255 Link One:5 Two:3 ULL:60 E:200 C:255 Link One:3 Two:2 ULL:60 E:200 C:255 Link One:2 Two:0 ULL:60 E:200 C:255 Link One:1 Two:2 ULL:110 E:200 C:0 Link One:7 Two:1 ULL:110 E:200 C:0 Link One:6 Two:3 ULL:110 E:200 C:0 Link One:5 Two:7 ULL:110 E:200 C:0 Link One:2 Two:5 ULL:110 E:200 C:0 Link One:3 Two:0 ULL:110 E:200 C:0 Link One:0 Two:4 ULL:110 E:200 C:0 Link One:4 Two:6 ULL:110 E:200 C:0 Link One:4 Two:3 ULL:150 E:50 C:0 Link One:5 Two:1 ULL:150 E:50 C:0 Link One:0 Two:6 ULL:150 E:50 C:0 Link One:2 Two:7 ULL:150 E:50 C:0 ";
            
            case Shoals._SMALLAMOEBA:
               return "Creature Key_Node:0 Data: 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 999 Fission Agent X:31481 Y:96719 D:29 C:496 Agent X:49097 Y:95381 D:29 C:496 Status:536870912 Agent X:48614 Y:77635 D:29 C:496 Agent X:52401 Y:86227 D:29 C:475 Agent X:30979 Y:79306 D:29 C:496 Write_point Agent X:27477 Y:87920 D:29 C:475 Agent X:39717 Y:75454 D:29 C:475 Agent X:41253 Y:98761 D:29 C:475 Read_point Link One:0 Two:5 ULL:37 E:200 C:255 Link One:5 Two:4 ULL:37 E:200 C:255 Link One:4 Two:6 ULL:37 E:200 C:255 Link One:6 Two:2 ULL:37 E:200 C:255 Link One:2 Two:3 ULL:37 E:200 C:255 Link One:3 Two:1 ULL:37 E:200 C:255 Link One:1 Two:7 ULL:37 E:200 C:255 Link One:7 Two:0 ULL:37 E:200 C:255 Link One:5 Two:6 ULL:68 E:200 C:0 Link One:6 Two:3 ULL:68 E:200 C:0 Link One:0 Two:1 ULL:68 E:200 C:0 Link One:2 Two:4 ULL:68 E:200 C:0 Link One:7 Two:5 ULL:68 E:200 C:0 Link One:4 Two:0 ULL:68 E:200 C:0 Link One:3 Two:7 ULL:68 E:200 C:0 Link One:1 Two:2 ULL:68 E:200 C:0 Link One:7 Two:6 ULL:93 E:50 C:0 Link One:2 Two:0 ULL:93 E:50 C:0 Link One:1 Two:4 ULL:93 E:50 C:0 Link One:5 Two:3 ULL:93 E:50 C:0 ";
            
            case Shoals._TADPOLES:
               return "Creature Key_Node:0 Data:0 Egg Egg_attached Agent X:15681 Y:31100 D:22 C:360 Agent X:8969 Y:33547 D:22 C:360 Agent X:31741 Y:29229 D:8 C:79 Status:402653184 Write_point Agent X:17924 Y:20304 D:36 Status:1677721600 Agent X:5643 Y:22370 D:36 Status:1677721600 Agent X:23123 Y:27307 D:17 C:357 Agent X:14652 Y:38665 D:22 C:359 Agent X:21561 Y:34388 D:20 C:358 Agent X:26849 Y:29142 D:13 C:356 Link One:4 Two:0 ULL:60 E:120 C:0 Link One:1 Two:0 ULL:30 E:120 C:0 Link One:1 Two:6 ULL:30 E:120 C:508 Link One:5 Two:8 ULL:20 E:120 C:508 Link One:7 Two:5 ULL:24 E:120 C:508 Link One:6 Two:7 ULL:30 E:120 C:508 Link One:6 Two:0 ULL:30 E:120 C:508 Link One:0 Two:3 ULL:44 E:120 C:510 Link One:3 Two:4 ULL:50 E:120 C:0 Link One:8 Two:2 ULL:17 E:120 C:508 Link One:3 Two:1 ULL:60 E:120 C:0 Link One:4 Two:1 ULL:44 E:120 C:510 ";
            
            case Shoals._SPERM:
            case Shoals._MIXTURE:
               return "Creature Key_Node:0 Data:0 Egg Egg_attached Agent X:9137 Y:11566 D:6 C:55 Agent X:13141 Y:11672 D:10 C:53 Agent X:6866 Y:10411 D:4 C:79 Write_point Status:402653184 Agent X:21868 Y:20181 D:21 Status:1677721600 Agent X:20336 Y:12261 D:21 Status:1677721600 Agent X:12257 Y:14974 D:8 C:55 Agent X:16123 Y:16369 D:16 C:51 Link One:3 Two:4 ULL:25 E:200 C:0 Link One:0 Two:2 ULL:8 E:120 C:508 Link One:6 Two:1 ULL:15 E:120 C:508 Link One:5 Two:0 ULL:10 E:120 C:508 Link One:1 Two:5 ULL:12 E:120 C:508 Link One:3 Two:6 ULL:24 E:160 C:511 Link One:4 Two:6 ULL:21 E:160 C:510 E:160 C:510 ";
            
            case Shoals._FOOTBALLERS:
               return "Creature Key_Node:0 Data:0 Egg Egg_attached Agent X:26971 Y:13065 D:21 C:380 Agent X:7424 Y:13201 D:56 Status:1677721600 Agent X:48416 Y:36156 D:14 C:375 Agent X:61723 Y:39314 D:9 C:79 Status:402653184 Write_point Agent X:28301 Y:22135 D:25 C:375 Agent X:41509 Y:34415 D:21 C:375 Agent X:7424 Y:48420 D:56 Status:1677721600 Agent X:24399 Y:36762 D:25 C:375 Agent X:55457 Y:36410 D:14 C:375 Agent X:33568 Y:30560 D:30 C:380 Agent X:18041 Y:42997 D:21 C:380 Agent X:19383 Y:52360 D:30 C:375 Agent X:19158 Y:12998 D:30 C:375 Link One:12 Two:0 ULL:31 E:150 C:508 Link One:7 Two:10 ULL:29 E:150 C:508 Link One:6 Two:3 ULL:270 E:10 C:0 Link One:8 Two:3 ULL:17 E:150 C:508 Link One:9 Two:1 ULL:130 E:200 C:0 Link One:2 Two:8 ULL:20 E:150 C:508 Link One:1 Two:3 ULL:270 E:10 C:0 Link One:1 Two:12 ULL:50 E:150 C:508 Link One:9 Two:5 ULL:27 E:150 C:508 Link One:11 Two:6 ULL:48 E:150 C:508 Link One:12 Two:0 ULL:31 E:150 C:508 Link One:9 Two:7 ULL:33 E:150 C:508 Link One:12 Two:11 ULL:160 E:20 C:0 Link One:0 Two:4 ULL:29 E:150 C:508 Link One:6 Two:9 ULL:130 E:200 C:0 Link One:4 Two:7 ULL:79 E:20 C:0 Link One:10 Two:0 ULL:137 E:20 C:0 Link One:5 Two:2 ULL:27 E:150 C:508 Link One:10 Two:11 ULL:31 E:150 C:508 Link One:1 Two:6 ULL:130 E:200 C:0 Link One:4 Two:9 ULL:34 E:150 C:508 ";
            
            case Shoals._WORMS:
               return "Creature Key_Node:0 Data:0 Egg Egg_attached Agent X:15136 Y:81410 D:14 C:407 Agent X:19673 Y:45165 D:30 C:404 Agent X:17537 Y:75486 D:14 C:406 Agent X:16324 Y:32081 D:34 Status:1677721600 Agent X:18194 Y:56410 D:21 C:404 Agent X:15806 Y:86095 D:9 C:7 Status:268435456 Write_point Agent X:19402 Y:64559 D:21 C:405 Link One:3 Two:5 ULL:216 E:10 C:0 Link One:6 Two:2 ULL:32 E:300 C:508 Link One:0 Two:5 ULL:17 E:300 C:508 Link One:1 Two:3 ULL:44 E:300 C:0 Link One:2 Two:0 ULL:20 E:300 C:508 Link One:1 Two:4 ULL:32 E:300 C:508 Link One:3 Two:1 ULL:45 E:160 C:508 Link One:4 Two:6 ULL:34 E:300 C:508 ";
            
            case Shoals._SPIDERS:
               return "Creature Key_Node:0 Data:0 Agent X:26365 Y:52234 D:29 C:48 Write_point Agent X:2816 Y:30793 D:21 C:467 Agent X:31296 Y:33603 D:31 C:56 Agent X:31997 Y:57789 D:31 C:56 Agent X:39178 Y:21132 D:23 C:472 Agent X:32156 Y:66831 D:28 C:480 Agent X:10302 Y:49531 D:24 C:472 Agent X:13680 Y:41387 D:28 C:480 Agent X:39092 Y:11894 D:20 C:467 Agent X:35468 Y:40574 D:27 C:48 Agent X:28758 Y:4700 D:21 C:467 Agent X:54193 Y:27590 D:21 C:467 Agent X:21975 Y:36675 D:29 C:56 Agent X:24377 Y:29389 D:24 C:255 Status:1677721600 Agent X:2816 Y:51460 D:20 C:467 Agent X:40770 Y:56095 D:29 C:56 Agent X:51846 Y:34917 D:24 C:472 Agent X:23529 Y:66296 D:24 C:472 Agent X:29296 Y:14275 D:24 C:472 Agent X:31009 Y:23807 D:29 C:480 Agent X:42022 Y:46905 D:31 C:56 Agent X:15760 Y:66575 D:19 C:467 Agent X:51401 Y:42491 D:27 C:480 Agent X:47002 Y:61555 D:18 C:7 Status:134217728 Agent X:18381 Y:52077 D:27 C:480 Agent X:40028 Y:31986 D:27 C:480 Agent X:16823 Y:29824 D:24 C:255 Status:1677721600 Agent X:21703 Y:44445 D:31 C:56 Agent X:7294 Y:36933 D:24 C:472 Link One:9 Two:25 ULL:30 E:160 C:255 Link One:0 Two:3 ULL:30 E:160 C:0 Link One:22 Two:20 ULL:30 E:160 C:0 Link One:27 Two:1 ULL:130 E:30 C:0 Link One:15 Two:3 ULL:30 E:160 C:0 Link One:22 Two:20 ULL:55 E:160 C:255 Link One:15 Two:23 ULL:30 E:160 C:0 Link One:15 Two:3 ULL:30 E:160 C:255 Link One:11 Two:20 ULL:130 E:30 C:0 Link One:23 Two:13 ULL:195 E:20 C:0 Link One:14 Two:6 ULL:30 E:160 C:255 Link One:9 Two:2 ULL:30 E:160 C:0 Link One:20 Two:22 ULL:30 E:160 C:0 Link One:18 Two:19 ULL:30 E:160 C:255 Link One:19 Two:2 ULL:30 E:160 C:0 Link One:18 Two:10 ULL:30 E:160 C:0 Link One:3 Two:27 ULL:61 E:200 C:0 Link One:1 Two:28 ULL:30 E:160 C:255 Link One:11 Two:23 ULL:110 E:20 C:0 Link One:13 Two:12 ULL:30 E:160 C:0 Link One:26 Two:12 ULL:30 E:160 C:0 Link One:26 Two:12 ULL:30 E:160 C:0 Link One:27 Two:12 ULL:30 E:160 C:0 Link One:7 Two:28 ULL:30 E:160 C:0 Link One:13 Two:12 ULL:30 E:160 C:255 Link One:2 Two:20 ULL:61 E:200 C:0 Link One:11 Two:16 ULL:30 E:160 C:255 Link One:24 Two:0 ULL:30 E:160 C:255 Link One:5 Two:17 ULL:30 E:160 C:0 Link One:21 Two:14 ULL:90 E:20 C:0 Link One:26 Two:12 ULL:30 E:160 C:0 Link One:2 Two:10 ULL:130 E:30 C:0 Link One:2 Two:9 ULL:30 E:160 C:0 Link One:26 Two:23 ULL:205 E:20 C:0 Link One:28 Two:7 ULL:30 E:160 C:255 Link One:11 Two:23 ULL:110 E:20 C:0 Link One:4 Two:8 ULL:30 E:160 C:0 Link One:7 Two:27 ULL:30 E:160 C:0 Link One:15 Two:3 ULL:30 E:160 C:0 Link One:9 Two:2 ULL:30 E:160 C:0 Link One:17 Two:21 ULL:30 E:160 C:0 Link One:16 Two:11 ULL:30 E:160 C:0 Link One:14 Two:6 ULL:30 E:160 C:0 Link One:14 Two:1 ULL:90 E:20 C:0 Link One:0 Two:14 ULL:130 E:30 C:0 Link One:12 Two:2 ULL:30 E:160 C:255 Link One:12 Two:27 ULL:30 E:160 C:255 Link One:10 Two:18 ULL:30 E:160 C:255 Link One:0 Two:3 ULL:30 E:160 C:255 Link One:3 Two:21 ULL:130 E:30 C:0 Link One:3 Two:0 ULL:30 E:160 C:0 Link One:4 Two:8 ULL:30 E:160 C:255 Link One:24 Two:6 ULL:30 E:160 C:0 Link One:2 Two:9 ULL:30 E:160 C:0 Link One:9 Two:8 ULL:130 E:30 C:0 Link One:1 Two:10 ULL:180 E:20 C:0 Link One:20 Two:9 ULL:30 E:160 C:0 Link One:9 Two:2 ULL:30 E:160 C:255 Link One:20 Two:15 ULL:30 E:160 C:255 Link One:13 Two:26 ULL:30 E:160 C:0 Link One:20 Two:3 ULL:61 E:200 C:0 Link One:27 Two:7 ULL:30 E:160 C:255 Link One:5 Two:3 ULL:30 E:160 C:255 Link One:16 Two:22 ULL:30 E:160 C:0 Link One:16 Two:22 ULL:30 E:160 C:0 Link One:5 Two:17 ULL:30 E:160 C:255 Link One:21 Two:14 ULL:90 E:20 C:0 Link One:10 Two:8 ULL:90 E:20 C:0 Link One:27 Two:2 ULL:61 E:200 C:0 Link One:0 Two:24 ULL:30 E:160 C:0 Link One:25 Two:4 ULL:30 E:160 C:255 Link One:28 Two:1 ULL:30 E:160 C:0 Link One:23 Two:21 ULL:110 E:20 C:0 Link One:20 Two:9 ULL:30 E:160 C:255 Link One:2 Two:9 ULL:30 E:160 C:0 Link One:15 Two:3 ULL:30 E:160 C:0 Link One:18 Two:10 ULL:30 E:160 C:0 Link One:9 Two:2 ULL:30 E:160 C:0 Link One:12 Two:26 ULL:30 E:160 C:255 Link One:24 Two:6 ULL:30 E:160 C:0 Link One:6 Two:24 ULL:30 E:160 C:255 Link One:2 Two:19 ULL:30 E:160 C:255 Link One:21 Two:17 ULL:30 E:160 C:255 Link One:20 Two:27 ULL:84 E:50 C:0 Link One:8 Two:11 ULL:90 E:20 C:0 Link One:23 Two:15 ULL:30 E:160 C:255 Link One:14 Two:1 ULL:90 E:20 C:0 Link One:22 Two:16 ULL:30 E:160 C:0 Link One:27 Two:0 ULL:30 E:160 C:255 Link One:26 Two:12 ULL:30 E:160 C:0 Link One:22 Two:16 ULL:30 E:160 C:255 Link One:2 Two:3 ULL:84 E:50 C:0 Link One:23 Two:21 ULL:110 E:20 C:0 Link One:1 Two:10 ULL:180 E:20 C:0 Link One:3 Two:15 ULL:30 E:160 C:0 ";
            
            case Shoals._SPIDERPLANTS:
               return "Creature Key_Node:0 Agent X:12129 Y:80304 D:24 C:60 Agent X:28544 Y:90684 D:30 C:56 Status:536870912 Write_point Agent X:21779 Y:61614 D:20 C:63 Agent X:8613 Y:99086 D:24 C:60 Agent X:37840 Y:96901 D:26 C:56 Agent X:8590 Y:109338 D:20 C:63 Agent X:21272 Y:81982 D:26 C:56 Agent X:2816 Y:79976 D:20 C:63 Agent X:48109 Y:109474 D:20 C:63 Agent X:27509 Y:112485 D:24 C:60 Agent X:34594 Y:103672 D:26 C:56 Agent X:21649 Y:71036 D:24 C:60 Agent X:48477 Y:71996 D:20 C:63 Agent X:49454 Y:120138 D:20 C:63 Agent X:27509 Y:122645 D:20 C:63 Agent X:38324 Y:82337 D:26 C:56 Agent X:59235 Y:96867 D:20 C:63 Agent X:28652 Y:79445 D:26 C:56 Agent X:27415 Y:102283 D:26 C:56 Agent X:42098 Y:111778 D:24 C:60 Agent X:41787 Y:90751 D:26 C:56 Agent X:48949 Y:96995 D:24 C:60 Agent X:15481 Y:90743 D:26 C:56 Agent X:43456 Y:101196 D:24 C:60 Agent X:38231 Y:72134 D:24 C:60 Link One:0 Two:6 ULL:36 E:160 C:255 Link One:1 Two:14 ULL:120 E:20 C:0 Link One:17 Two:11 ULL:36 E:160 C:255 Link One:1 Two:8 ULL:120 E:20 C:0 Link One:8 Two:23 ULL:36 E:160 C:255 Link One:14 Two:9 ULL:36 E:160 C:255 Link One:1 Two:16 ULL:120 E:20 C:0 Link One:7 Two:0 ULL:36 E:160 C:255 Link One:13 Two:14 ULL:140 E:10 C:0 Link One:8 Two:13 ULL:140 E:10 C:0 Link One:1 Two:12 ULL:120 E:20 C:0 Link One:12 Two:16 ULL:140 E:10 C:0 Link One:2 Two:12 ULL:140 E:10 C:0 Link One:1 Two:6 ULL:44 E:160 C:255 Link One:21 Two:4 ULL:36 E:160 C:255 Link One:3 Two:22 ULL:36 E:160 C:255 Link One:1 Two:22 ULL:44 E:160 C:255 Link One:5 Two:7 ULL:140 E:10 C:0 Link One:2 Two:7 ULL:140 E:10 C:0 Link One:16 Two:8 ULL:140 E:10 C:0 Link One:4 Two:1 ULL:44 E:160 C:255 Link One:9 Two:18 ULL:36 E:160 C:255 Link One:20 Two:1 ULL:44 E:160 C:255 Link One:13 Two:19 ULL:36 E:160 C:255 Link One:14 Two:5 ULL:140 E:10 C:0 Link One:1 Two:13 ULL:120 E:20 C:0 Link One:1 Two:5 ULL:120 E:20 C:0 Link One:5 Two:3 ULL:36 E:160 C:255 Link One:17 Two:1 ULL:44 E:160 C:255 Link One:12 Two:24 ULL:36 E:160 C:255 Link One:6 Two:1 ULL:44 E:160 C:255 Link One:1 Two:7 ULL:120 E:20 C:0 Link One:18 Two:1 ULL:44 E:160 C:255 Link One:15 Two:1 ULL:44 E:160 C:255 Link One:1 Two:6 ULL:44 E:160 C:255 Link One:23 Two:20 ULL:36 E:160 C:255 Link One:16 Two:21 ULL:36 E:160 C:255 Link One:2 Two:11 ULL:36 E:160 C:255 Link One:10 Two:1 ULL:44 E:160 C:255 Link One:15 Two:24 ULL:36 E:160 C:255 Link One:19 Two:10 ULL:36 E:160 C:255 Link One:1 Two:2 ULL:120 E:20 C:0 ";
            
            case Shoals._SMALLSPINES:
               return "Creature Key_Node:0 Egg Agent X:4956 Y:35879 D:12 C:63 Agent X:11129 Y:23988 D:18 C:56 Status:536870912 Write_point Agent X:19330 Y:26713 D:16 C:56 Agent X:21356 Y:35393 D:12 C:127 Agent X:6916 Y:11664 D:12 C:63 Agent X:22655 Y:18427 D:12 C:63 Agent X:19040 Y:22025 D:16 C:56 Agent X:24269 Y:28301 D:12 C:127 Agent X:11164 Y:35492 D:12 C:127 Agent X:12148 Y:30572 D:16 C:56 Agent X:16219 Y:32083 D:16 C:56 Agent X:6841 Y:18139 D:16 C:56 Agent X:3485 Y:23838 D:16 C:56 Agent X:6872 Y:30528 D:16 C:56 Agent X:11465 Y:16356 D:16 C:56 Agent X:3596 Y:14284 D:12 C:127 Agent X:1792 Y:19612 D:12 C:127 Link One:13 Two:1 ULL:27 E:160 C:255 Link One:9 Two:1 ULL:27 E:160 C:255 Link One:11 Two:1 ULL:27 E:160 C:255 Link One:1 Two:12 ULL:27 E:160 C:255 Link One:12 Two:1 ULL:27 E:160 C:255 Link One:2 Two:1 ULL:27 E:160 C:255 Link One:1 Two:12 ULL:27 E:160 C:255 Link One:1 Two:14 ULL:27 E:160 C:255 Link One:10 Two:1 ULL:27 E:160 C:255 Link One:6 Two:1 ULL:27 E:160 C:255 Link One:2 Two:1 ULL:27 E:160 C:255 Link One:0 Two:13 ULL:20 E:160 C:255 Link One:2 Two:7 ULL:20 E:160 C:255 Link One:12 Two:16 ULL:20 E:160 C:255 Link One:6 Two:5 ULL:20 E:160 C:255 Link One:14 Two:4 ULL:20 E:160 C:255 Link One:9 Two:8 ULL:20 E:160 C:255 Link One:11 Two:15 ULL:20 E:160 C:255 Link One:10 Two:3 ULL:20 E:160 C:255 Link One:5 Two:1 ULL:60 E:5 C:0 Link One:15 Two:1 ULL:60 E:5 C:0 Link One:8 Two:1 ULL:60 E:5 C:0 Link One:3 Two:1 ULL:60 E:5 C:0 Link One:7 Two:1 ULL:60 E:5 C:0 Link One:16 Two:1 ULL:60 E:5 C:0 Link One:0 Two:1 ULL:60 E:5 C:0 Link One:4 Two:1 ULL:60 E:5 C:0 ";
         }
      
         return " ";
      }
   
   
      final public void add() {
         Shoals_Input.addFromString(getCreatureDescription(Shoals.initial_type),Shoals.entity_manager,0,0,128 + rnd.nextInt(128));
      }
   
   /*
      public Entity copy(Entity e) {
         // number_of_agents++;
         new_array_of_agents = new Entity[number_of_agents + 1];
      
         for (temp = 0; temp < number_of_agents; temp++) {
            new_array_of_agents[temp] = agent[temp];
         }
      
         new_array_of_agents[number_of_agents] = new Entity(e);
      
         agent = new_array_of_agents;
      
         return agent[number_of_agents++];
      }
   */
   
     // called on resize...
      final public void resetEntityGrid() {
         gcd = (general_eggsize + general_size + 4) << shift;
      
         temp = 12;
      
         while (gcd > (1 << temp)) {
            temp++;
         }
      
         entity_grid = new EntityGrid(temp);
      
         ensureEntitiesAreBinnedAgain();
      }
   
   
      final public void ensureEntitiesAreBinnedAgain() {
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].current_bin_x = -1;
            agent[temp].current_bin_y = -1;
         }
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            ((Entity)leader[temp]).current_bin_x = -1;
            ((Entity)leader[temp]).current_bin_y = -1;
         }
      }
   
   
      final public void bufferedUpdate() {
         if (Shoals.use_links) {
            if (number_of_links > 0) {
               link_manager.scrubTheLinks();
               link_manager.exerciseTheLinks();
            }
         }
      
         if (number_of_leaders > 0) {
            scrubTheLeaders();
            if (!Shoals.paused) {
               travelTheLeaders();
            }
         }
      
         if (number_of_agents > 0) {
            scrubTheAgents();
            if (!Shoals.paused) {
               travelTheAgents();
            }
         }
      
         if (Shoals.use_links) {
            if (number_of_links > 0) {
               link_manager.drawTheLinks();
            }
         }
      
         apply_acceleration();
      
         if (number_of_leaders > 0) {
            drawTheLeaders();
         }
      
      
         if (number_of_agents > 0) {
            drawTheAgents();
         }
      
      
         if (Shoals.check_collisions) {
            if (!Shoals.paused) {
               collisionCheck();
            }
         }
      }
   
   
      final public void unbufferedAgentUpdate() {
         Entity.temp_private_world = this;
         if (Shoals.frame_frequency == 0) {
            if (number_of_agents > 0) {
               if ((Shoals.quality == Shoals._QUALITY_1) || (Shoals.quality == Shoals._QUALITY_2)) {
                  for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                     Shoals_Grid.colourZero();
                     agent[agent_counter].scrub();
                  
                     if (!Shoals.paused) {
                        agent[agent_counter].travel();
                     }
                  
                     agent[agent_counter].draw();
                  }
               }
               else
               {
                  if (Shoals.quality == Shoals._QUALITY_3) {
                     for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                        agent[agent_counter].scrub();
                     
                        if (!Shoals.paused) {
                           agent[agent_counter].travel();
                        }
                     
                        agent[agent_counter].draw();
                     }
                  }
                  else
                  {
                     {
                        for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
                           agent[agent_counter].scrub();
                        
                           if (!Shoals.paused) {
                              agent[agent_counter].travel();
                           }
                        
                           agent[agent_counter].draw();
                        }
                     }
                  }
               }
            }
         
         
            if (number_of_leaders > 0) {
               for (agent_counter = number_of_leaders; --agent_counter >= 0; ) {
               // for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
                  Shoals_Grid.colourZero();
                  leader[agent_counter].scrub();
               
                  if (!Shoals.paused) {
                     leader[agent_counter].travel();
                  }
               
                  leader[agent_counter].draw();
               }
            }
         
         
            if (Shoals.use_links) {
               if (number_of_links > 0) {
                  link_manager.linkUpdating();
               }
            }
         
            if (!Shoals.paused) {
               apply_acceleration();
               if (Shoals.check_collisions) {
                  collisionCheck();
               }
            }
         }
         else
         {
            if (number_of_agents > 0) {
               scrubTheAgents();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (number_of_agents > 0) {
                     travelTheAgents();
                  }
               
                  if (Shoals.use_links) {
                     if (number_of_links > 0) {
                        link_manager.linkUpdating();
                     }
                  }
               
                  apply_acceleration();
                  if (Shoals.check_collisions) {
                     collisionCheck();
                  }
               }
            }
         
            if (number_of_agents > 0) {
               drawTheAgents();
            }
         
            if (number_of_leaders > 0) {
               scrubTheLeaders();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (number_of_leaders > 0) {
                     travelTheLeaders();
                  }
               
                  if (Shoals.check_collisions) {
                     collisionCheck();
                  }
               }
            }
         
            if (number_of_leaders > 0) {
               drawTheLeaders();
            }
         }
      }
   
   
      final public void collisionCheckNbyN() {
         for (temp = 0; temp < (number_of_agents + number_of_leaders - 1); temp++) {
            setUpTempAgent();
            for (temp2 = temp + 1; temp2 < (number_of_agents + number_of_leaders); temp2++) {
               setUpTemp2Agent();
               collideTheseEntities();
            }
         }
      }
   
   
      final public void collisionCheck() {
         if (Shoals.oscd) {
            collisionCheckNbyN();
         }
         else
         {
            findNewBins();
         
            for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
               setUpTempAgent();
            
               new_bin_x = temp_agent.current_bin_x; //temp_agent.x >>> EntityGrid.log2binsize;
               new_bin_y = temp_agent.current_bin_y; //temp_agent.y >>> EntityGrid.log2binsize;
            
               // C
               list = entity_grid.entity_list[new_bin_x][new_bin_y];
               temp3 = list.getNumberInList(temp_agent) + 1;
               if (temp3 < list.current_number) {
                  for (temp2 = temp3; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                  
                     collideTheseEntities();
                  }
               }
            
               // W
               if (new_bin_x > 0) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               
               // NW
                  if (new_bin_y > 0) {
                     list = entity_grid.entity_list[new_bin_x - 1][new_bin_y - 1];
                     for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                        temp2_agent = list.entity[temp2];
                        collideTheseEntities();
                     }
                  }
               
               	// SW
                  if (new_bin_y < (EntityGrid.ny - 1)) {
                     list = entity_grid.entity_list[new_bin_x - 1][new_bin_y + 1];
                     for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                        temp2_agent = list.entity[temp2];
                        collideTheseEntities();
                     }
                  }
               }
            
               // U
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x][new_bin_y - 1];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               }
            }
         }
      }
   
   
      final public void setUpTempAgent() {
         if (temp < number_of_agents) {
            temp_agent = agent[temp];
         }
         else
         {
            temp_agent = (Entity)leader[temp - number_of_agents];
         }
      }
   
   
      final public void setUpTemp2Agent() {
         if (temp2 < number_of_agents) {
            temp2_agent = agent[temp2];
         }
         else
         {
            temp2_agent = (Entity)leader[temp2 - number_of_agents];
         }
      }
   
   
      final public void findNewBins() {
         for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
            setUpTempAgent();
         
            new_bin_x = temp_agent.x >>> EntityGrid.log2binsize;
            new_bin_y = temp_agent.y >>> EntityGrid.log2binsize;
         
            if (new_bin_x < 0) new_bin_x = 0;
            if (new_bin_y < 0) new_bin_y = 0;
         
            if ((temp_agent.current_bin_x != new_bin_x) || (temp_agent.current_bin_y != new_bin_y)) {
               EntityGrid.addToList(new_bin_x, new_bin_y, temp_agent);
               EntityGrid.removeFromList(temp_agent.current_bin_x, temp_agent.current_bin_y, temp_agent);
            
               temp_agent.current_bin_x = new_bin_x;
               temp_agent.current_bin_y = new_bin_y;
            }
         }
      }
   
   
      boolean sameSign(int a, int b) {
         return (((a ^ b) & 0x80000000) == 0);
      }
   
   
      final public void apply_acceleration() {
         // apply acceleration...
         if (number_of_agents > 0) {
            for (temp = 0; temp < number_of_agents; temp++) {
               temp_agent = agent[temp];
               if (!Shoals.gas_sim) {
                  if (number_of_leaders > 0) {
                  // turn about...
                  
                  // for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
                     temp2 = 0;
                     // temp4 = temp_agent.x - ((Entity)leader[temp2]).x;
                     // temp5 = temp_agent.y - ((Entity)leader[temp2]).y;
                     temp_agent.preferred_direction = (byte)(arcTangent(temp_agent.x - ((Entity)leader[temp2]).x, temp_agent.y - ((Entity)leader[temp2]).y) + Entity.direction_bias);
                  
                     /*if ((temp4 < 0) && (temp5 < 0)) {
                        temp3 = rnd.nextInt();
                        if (temp4 < temp5) {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + Entity.direction_bias;
                        }
                        else
                        {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 4 + Entity.direction_bias;
                        }
                     }
                     else
                     {
                        if ((temp4 < 0) && (temp5 >= 0)) {
                           temp3 = rnd.nextInt();
                           if (-temp4 < temp5) {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 24 + Entity.direction_bias;
                           }
                           else
                           {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 28 + Entity.direction_bias;
                           }
                        }
                        else
                        {
                           if ((temp4 >= 0) && (temp5 < 0)) {
                              temp3 = rnd.nextInt();
                              if (temp4 < -temp5) {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 8 + Entity.direction_bias;
                              }
                              else
                              {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 12 + Entity.direction_bias;
                              }
                           }
                           else
                           {
                              if ((temp4 > 0) && (temp5 >= 0)) {
                                 temp3 = rnd.nextInt();
                                 if (temp4 > temp5) {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 16 + Entity.direction_bias;
                                 }
                                 else
                                 {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 20 + Entity.direction_bias;
                                 }
                              }
                           }
                        }
                     	*/
                  
                  // conditionally...
                     temp_agent.thrust(towards_leader);
                  }
               }
            
               temp_agent.dy += gravity;
            }
         }
      
         // apply acceleration to leader...
         if (!Shoals.gas_sim) {
            if (number_of_leaders > 0) {
               for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
                  if (((Entity)leader[temp2]).x < (Shoals_Canvas.current_mouse_x)) {
                     ((Entity)leader[temp2]).dx += acc_of_leader;
                  }
                  else
                  {
                     if (((Entity)leader[temp2]).x > (Shoals_Canvas.current_mouse_x)) {
                        ((Entity)leader[temp2]).dx -= acc_of_leader;
                     }
                  }
               
                  if (((Entity)leader[temp2]).y < (Shoals_Canvas.current_mouse_y)) {
                     ((Entity)leader[temp2]).dy += acc_of_leader;
                  }
                  else
                  {
                     if (((Entity)leader[temp2]).y > (Shoals_Canvas.current_mouse_y)) {
                        ((Entity)leader[temp2]).dy -= acc_of_leader;
                     }
                  }
               
                  ((Entity)leader[temp2]).dy += gravity;
               }
            }
         }
      }
   
   
      final public byte arcTangent(int dx, int dy) {
         temp3 = rnd.nextInt();
         if ((dx < 0) && (dy < 0)) {
            if (dx < dy) {
               return (byte)((temp3 & 3) + (temp3 >>> 31));
            }
            else
            {
               return (byte)((temp3 & 3) + (temp3 >>> 31) + 4);
            }
         }
         else
         {
            if ((dx < 0) && (dy >= 0)) {
               if (-dx < dy) {
                  return (byte)((temp3 & 3) + (temp3 >>> 31) + 24);
               }
               else
               {
                  return (byte)(((temp3 & 3) + (temp3 >>> 31) + 28) & Entity.TRIG_TAB_SIZEMO);
               }
            }
            else
            {
               if ((dx >= 0) && (dy < 0)) {
                  if (dx < -dy) {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 8);
                  }
                  else
                  {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 12);
                  }
               }
               else
               {
                  //if ((dx > 0) && (dy >= 0)) {
                  if (dx > dy) {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 16);
                  }
                  else
                  {
                     return (byte)((temp3 & 3) + (temp3 >>> 31) + 20);
                  }
                  // }
               }
            }
         }
      }
   
   
   // accepts temp_agent and temp2_agent
      final public void collideTheseEntities() {
         temp_detection_distance = (int)temp_agent.detection_radius + (int)temp2_agent.detection_radius; // get this outside the loop?
         temp_detection_distance2 = temp_detection_distance << shift;
         temp3 = temp_agent.x - temp2_agent.x;
         temp5 = (temp3 < 0) ? -temp3 : temp3; // hmmm...
         if (temp5 < temp_detection_distance2) {
            temp4 = temp_agent.y - temp2_agent.y;
            temp6 = (temp4 < 0) ? -temp4 : temp4;
            if (temp6 < temp_detection_distance2) {
               // probable collision...
            // outer diamond check...
               if ((((temp_detection_distance2) + (temp_detection_distance2 >> 1)) - temp5) > temp6) {
               
               // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  // temp_detection_distance = temp_detection_distance >> shift;
                  temp_detection_distance_squared = temp_detection_distance * temp_detection_distance; // temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
                  if (temp_radius < temp_detection_distance_squared) {
                  // collision 
                     collide_with_self = ((temp_agent.creature == temp2_agent.creature) && (temp_agent.creature != null));
                  // sqrt - really? :-(
                     temp_radius = SquareRoot.sqrt(1 + temp_radius);
                  
                  // find unit vector along collision path...
                     temp_x = (temp3) / temp_radius; // unit vector * 65536
                     temp_y = (temp4) / temp_radius;
                  
                        // debug("temp_x:" + temp_x + " - temp_y:" + temp_y); // seems ok
                  
                        // compute the relative velocities...
                  
                     tadx = temp_agent.dx - temp2_agent.dx;
                     tady = temp_agent.dy - temp2_agent.dy;
                  
                  // dot product...
                     magnitude = -(((tadx * temp_x) + (tady * temp_y)) >> shift);
                     // magnitude = (magnitude < 0) ? -magnitude : magnitude;
                  
                     if (magnitude > 0) {
                        if (collide_with_self) {
                           temp_count = ((temp_detection_distance - temp_radius) << 6);
                        }
                        else
                        {
                           temp_count = ((temp_detection_distance - temp_radius) << 8) + minimum_magnitude;
                           if (((temp_agent.status & Entity.DEADLY) != 0) && ((temp2_agent.status & Entity.IMMORTAL) == 0)) {
                              if ((temp2_agent.status & Entity.DEATH_MASK) == 0) {
                                 creature_manager.infectCreature(temp2_agent, temp_agent);
                              }
                           } 
                           else
                           {
                              if (((temp2_agent.status & Entity.DEADLY) != 0) && ((temp_agent.status & Entity.IMMORTAL) == 0)) {
                                 if ((temp_agent.status & Entity.DEATH_MASK) == 0) {
                                    creature_manager.infectCreature(temp_agent, temp2_agent);
                                 }
                              }
                           }
                        }
                     
                        if (temp_count > maximum_magnitude) {
                           temp_count = maximum_magnitude;
                        }
                     
                     //if (magnitude <= 0) {
                        //magnitude = -magnitude; // temp_count;
                     //}
                     
                     
                        if (magnitude < temp_count) {
                           magnitude = temp_count;
                        }
                     
                        // crude hack - since impulse calculations don't seem to be running yet...
                     
                        temp_x = temp_x * magnitude;
                        temp_y = temp_y * magnitude;
                     
                        temp_ma = (temp_agent.log_mass - temp2_agent.log_mass);
                     
                        if (temp_ma < 0) {
                           tadx = temp_x >> -temp_ma;
                           tady = temp_y >> -temp_ma;
                        
                           temp_agent.dx += tadx >> 9;
                           temp_agent.dy += tady >> 9;
                           temp2_agent.dx -= ((temp_x << 1) - tadx) >> 9;
                           temp2_agent.dy -= ((temp_y << 1) - tady) >> 9;
                        }
                        else
                        {
                           tadx = temp_x >> temp_ma;
                           tady = temp_y >> temp_ma;
                        
                           temp_agent.dx += ((temp_x << 1) - tadx) >> 9;
                           temp_agent.dy += ((temp_y << 1) - tady) >> 9;
                           temp2_agent.dx -= tadx >> 9;
                           temp2_agent.dy -= tady >> 9;
                        }
                     }
                  
                     //}
                     //else // already moving apart from one another...
                     //{
                     //}
                  
                        //}
                        // }
                        /*else
                        {
                           temp_agent.dx += temp_x << 2;
                           temp_agent.dy += temp_y << 2;
                           temp2_agent.dx -= temp_x << 2;
                           temp2_agent.dy -= temp_y << 2;
                        }*/
                  
                           /*
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           }
                           
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           } */
                           /*
                           temp_count = 12;
                           
                           do {
                           temp_agent.x += (tadx >> 4);
                           temp_agent.y += (tady >> 4);
                           temp2_agent.x -= (tadx >> 4);
                           temp2_agent.y -= (tady >> 4);
                           
                           temp3 = temp_agent.x - temp2_agent.x;
                           temp5 = (temp3 < 0) ? -temp3 : temp3;
                           
                           temp4 = temp_agent.y - temp2_agent.y;
                           temp6 = (temp4 < 0) ? -temp4 : temp4;
                           
                           temp_radius = (temp5 * temp5) + (temp6 * temp6);  // now check using circle...
                           } while ((temp_radius < detection_radius_squared) && (temp_count-- > 0));
                           */
                  
                           /*
                           temp_agent.x += temp_agent.dx;
                           temp_agent.y += temp_agent.dy;
                           temp2_agent.x += temp2_agent.dx;
                           temp2_agent.y += temp2_agent.dy;
                           */
                  
                  }
               }
            }
         }
      }
   
   
      final public Entity isThereOne2(int x, int y) {
         for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
            setUpTempAgent();
            temp_detection_distance = ((int)temp_agent.detection_radius) << shift;// + temp2_agent.detection_radius;
            temp3 = temp_agent.x - x;
            temp5 = (temp3 < 0) ? -temp3 : temp3;
            if (temp5 < temp_detection_distance) {
               temp4 = temp_agent.y - y;
               temp6 = (temp4 < 0) ? -temp4 : temp4;
               if (temp6 < temp_detection_distance) {
                  // probable collision...
                  // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  temp_detection_distance_squared = temp_agent.detection_radius * temp_agent.detection_radius;
                  if (temp_radius < temp_detection_distance_squared) {
                     // collision 
                     return temp_agent;
                  }
               }
            }
         }
      
         return null;
      }
   
   
      final public Entity isThereOne(int x, int y) {
         if (Shoals.oscd) {
            return isThereOne2(x,y);
         }
         else
         {
            new_bin_x = x >>> EntityGrid.log2binsize;
            new_bin_y = y >>> EntityGrid.log2binsize;
         
            if (new_bin_x < 0) 
               new_bin_x = 0;
         
            if (new_bin_x >= EntityGrid.nx) 
               new_bin_x = EntityGrid.nx - 1;
         
            if (new_bin_y < 0) 
               new_bin_y = 0;
         
            if (new_bin_y >= EntityGrid.ny) 
               new_bin_y = EntityGrid.ny - 1;
         
            list = entity_grid.entity_list[new_bin_x][new_bin_y];
         
            temp_agent = checkThisList(x, y);
            if (temp_agent != null) {
               return temp_agent;
            }
         
            if (new_bin_x > 0) {
               list = entity_grid.entity_list[new_bin_x - 1][new_bin_y];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y - 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            
               if (new_bin_y < (EntityGrid.ny - 1)) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y + 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            }
         
            if (new_bin_x < (EntityGrid.nx - 1)) {
               list = entity_grid.entity_list[new_bin_x + 1][new_bin_y];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x + 1][new_bin_y - 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            
               if (new_bin_y < (EntityGrid.ny - 1)) {
                  list = entity_grid.entity_list[new_bin_x + 1][new_bin_y + 1];
               
                  temp_agent = checkThisList(x, y);
                  if (temp_agent != null) {
                     return temp_agent;
                  }
               }
            }
         
            // D
            if (new_bin_y > 0) {
               list = entity_grid.entity_list[new_bin_x][new_bin_y - 1];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            }
         
         	// U
            if (new_bin_y < (EntityGrid.ny - 1)) {
               list = entity_grid.entity_list[new_bin_x][new_bin_y + 1];
            
               temp_agent = checkThisList(x, y);
               if (temp_agent != null) {
                  return temp_agent;
               }
            }
         }
      
         return null;
      }
   
   
      Entity checkThisList(int x, int y) {
         for (temp = 0; temp < list.current_number; temp++) {
            temp_agent = list.entity[temp];
            temp_detection_distance = ((int)temp_agent.detection_radius) << shift;
            temp3 = temp_agent.x - x;
            temp5 = (temp3 < 0) ? -temp3 : temp3;
            if (temp5 < temp_detection_distance) {
               temp4 = temp_agent.y - y;
               temp6 = (temp4 < 0) ? -temp4 : temp4;
               if (temp6 < temp_detection_distance) {
                  // probable collision...
                  // make smaller to prevent overflow...
                  tadx = (temp5 >> shift);
                  tady = (temp6 >> shift);
                  temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
                  temp_detection_distance_squared = temp_agent.detection_radius * temp_agent.detection_radius;
                  // emp_detection_distance_squared *= temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
                  if (temp_radius < temp_detection_distance_squared) {
                     // collision 
                     return temp_agent;
                  }
               }
            }
         }
      
         return null;
      }
   
   
      final void drawTheAgents() {
         Shoals_Grid.last_colour = -1;
         // Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].draw();
         }
      }
   
   
      final void scrubTheAgents() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].scrub();
         }
      }
   
   
      final void travelTheAgents() {
         Entity.temp_private_world = this;
         // for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
         for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            agent[agent_counter].travel();
         }
      }
   
   
      final void drawTheLeaders() {
         Shoals_Grid.last_colour = -1;
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].draw();
         }
      }
   
   
      final void travelTheLeaders() {
         Entity.temp_private_world = this;
         // for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
         for (agent_counter = number_of_leaders; --agent_counter >= 0; ) {
            leader[agent_counter].travel();
         }
      }
   
   
      final void scrubTheLeaders() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].scrub();
         }
      }
   
   
      public void setGlobalSize(byte d) {
         general_size = d;
      
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].setInitialSize(d,d);
         }
      
         for (temp = 0; temp < Entity.TRIG_TAB_SIZE; temp++) {
            Entity.ship_image_array[temp] = null;
         }
      }
   
   
      public void setGlobalEggSize(byte d) {
         general_eggsize = d;
      
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].setInitialSize(d,d);
         }
      
         Entity.ring_image = null;
      }
   
   
      final void changeNumber() {
         if ((target_number_of_agents != number_of_agents)) {
            while (target_number_of_agents > number_of_agents) {
               addNewAgent();
            }
         
            while (target_number_of_agents < number_of_agents) {
               killAgent();
            }
         
            resetEntityGrid();
         }
      }
   
   
      final void changeLeaderNumber() {
         if ((target_number_of_leaders != number_of_leaders)) {
            while (target_number_of_leaders > number_of_leaders) {
               addNewLeader();
            }
         
            while (target_number_of_leaders < number_of_leaders) {
               killLeader();
            }
         
            resetEntityGrid();
         }
      }
   
   
   
      // wastes memory, but who cares?
      final void addNewLeader() {
         number_of_leaders++;
      
         new_array_of_leaders = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < (number_of_leaders - 1); temp++) {
            new_array_of_leaders[temp] = leader[temp];
         }
      
         if (number_of_leaders > 1) {
            temp = rnd.nextInt(number_of_leaders - 1);
            temp_x = ((Entity)leader[temp]).x + rnd.nextInt(256);
            temp_y = ((Entity)leader[temp]).y + rnd.nextInt(256);
         
            new_array_of_leaders[number_of_leaders - 1] = new Entity_Leader(temp_x, temp_y, rnd.nextInt());
            ((Entity)new_array_of_leaders[number_of_leaders - 1]).colour = ((Entity)leader[temp]).colour;
            ((Entity)new_array_of_leaders[number_of_leaders - 1]).setSize((byte)(((Entity)leader[temp]).diameter));
         }
         else
         {
            temp_x = rnd.nextInt(Shoals_Canvas.gsx) << shift;
            temp_y = rnd.nextInt(Shoals_Canvas.gsy) << shift;
         
            new_array_of_leaders[number_of_leaders - 1] = new Entity_Leader(temp_x, temp_y, rnd.nextInt());
         }
      
         leader = new_array_of_leaders;
      }
   
   
      final void killAgent() {
         if (number_of_agents > 0) {
            link_manager.killAllLinks(agent[number_of_agents - 1]);
            number_of_agents--;
         }
      }
   
   
      final boolean killThisEntity(Entity e) {
         for (temp = 0; temp < number_of_agents; temp++) {
            if (agent[temp] == e) {
               killNumberedAgent(temp);
               return true;
            }
         }
      
         for (temp = 0; temp < (number_of_leaders); temp++) {
            if ((Entity)leader[temp] == e) {
               killNumberedLeader(temp);
               return true;
            }
         }
      
         return false;
      }
   
   
      final void killNumberedAgent(int n) {
         temp_agent = agent[n];
         temp_agent.scrub();
         link_manager.killAllLinks(temp_agent);
      
         agent[n] = agent[number_of_agents - 1];
         agent[--number_of_agents] = temp_agent;
      
         // IMPORTANT: remove it from the bins...
         temp_agent.removeFromBin();
      }
   
   
      final void killNumberedLeader(int n) {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         leader[n].scrub();
         link_manager.killAllLinks(leader[n]);
         temp_leader = leader[n];
         leader[n] = leader[number_of_leaders - 1];
         leader[--number_of_leaders] = temp_leader;
      }
   
   
      final void killLeader() {
         number_of_leaders--;
      }
   
   
      // returns distance in pixels...
      final int distanceBetween(Entity e1, Entity e2) {
         temp2 = (e1.x - e2.x) >> shift;
         temp3 = (e1.y - e2.y) >> shift;
         temp_radius = temp2 * temp2 + temp3 * temp3;
      
         return SquareRoot.sqrt(temp_radius);
      }
   
   
      final Entity getSelectedEntity() {
         for (temp = 0; temp < (number_of_agents); temp++) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               return agent[temp];
            }
         }
      
         return null;
      }
   
   
      final void deselectAll() {
         for (temp = 0; temp < (number_of_agents); temp++) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               agent[temp].scrub();
               agent[temp].status &= (-1 ^ Entity.SELECTED);
            }
         }
      }
   
   
      final void deleteSelected() {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               Shoals.killAllLinks(temp_agent);
               killThisEntity(temp_agent);
               temp2--;
            }
         }
      }
   
   
      final void setColourOfSelected(int c) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.colour = (char)c;
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      final void setSizeOfSelected(byte s) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.setInitialSize(s,s);
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      final void affectStatusBits(int and, int xor) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.status = (temp_agent.status & and) ^ xor;
               // Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
   
      final void moveSelection(int _dx, int _dy) {
         for (temp2 = 0; temp2 < number_of_agents; temp2++) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.x += _dx;
               temp_agent.y += _dy;
               temp_agent.dx = 0;
               temp_agent.dy = 0;
            
               temp_agent.boundaryCheck();
            
               // make sure bins are updated...
               temp_agent.findNewBin();
            }
         }
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
