/*
 * LineFragment Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class LineFragment extends Object {
      int x;
      int y;
   
      int dx;
      int dy;
   
      int direction;
      int angular_velocity;
   
      byte length;
      byte count;
   
      // length increment should exist as well...
   
      static int temp_x;
      static int temp_y;
   
      static int temp_dx;
      static int temp_dy;
   
      static int temp;
   
      static int size_x;
      static int size_y;
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      LineFragment(int ix, int iy, int jx, int jy, int idx, int idy, int rotspeed) {
         x = (ix + jx) >> 1;
         y = (iy + jy) >> 1;
      
         jx = (jx - ix) >> Entity.shift;
         jy = (jy - iy) >> Entity.shift;
      
         length = (byte)((SquareRoot.sqrt(1 + (jx * jx) + (jy * jy)) >> 1));
      
         dx = idx;
         dy = idy;
      
         direction = (Shoals.entity_manager.arcTangent(jx, jy)) << 8;
      
         angular_velocity = rnd.nextInt(rotspeed) - (rotspeed >> 1);
         if ((angular_velocity < 256) && (angular_velocity >= 0)) {
            angular_velocity = 256;
         }
         if ((angular_velocity > -256) && (angular_velocity <= 0)) {
            angular_velocity = -256;
         }
      
         count = (byte)((x + dx + dy) & 63);
      }
   
   
      // in internal co-ordinates....
      final public void set(int ix, int iy, int jx, int jy, int idx, int idy, int rotspeed) {
         x = (ix + jx) >> 1;
         y = (iy + jy) >> 1;
      
         jx = (jx - ix) >> Entity.shift;
         jy = (jy - iy) >> Entity.shift;
      
         length = (byte)((SquareRoot.sqrt(1 + (jx * jx) + (jy * jy)) >> 1));
      
         dx = idx;
         dy = idy;
      
         direction = (Shoals.entity_manager.arcTangent(jx, jy)) << 8;
      
         angular_velocity = rnd.nextInt(rotspeed) - (rotspeed >> 1);
         if ((angular_velocity < 128) && (angular_velocity > 0)) {
            angular_velocity = 128;
         }
         if ((angular_velocity > -128) && (angular_velocity < 0)) {
            angular_velocity = -128;
         }
      
         count = (byte)((x + dx + dy) & 63);
      }
   
   
      public void draw() {
         temp_x = (x >>> Entity.shift);
         temp_y = (y >>> Entity.shift);
      
         temp_dx = (length * Entity.cos_tab[direction >>> 8]) >> Entity.lut_shift;
         temp_dy = (length * Entity.sin_tab[direction >>> 8]) >> Entity.lut_shift;
      
         Shoals_Grid.graphics_handle.drawLine(temp_x - temp_dx, temp_y - temp_dy,temp_x + temp_dx, temp_y + temp_dy);
      }
   
   
      public void scrub() {
         temp_x = (x >>> Entity.shift);
         temp_y = (y >>> Entity.shift);
      
         temp_dx = (length * Entity.cos_tab[direction >>> 8]) >> Entity.lut_shift;
         temp_dy = (length * Entity.sin_tab[direction >>> 8]) >> Entity.lut_shift;
      
         Shoals_Grid.graphics_handle.drawLine(temp_x - temp_dx, temp_y - temp_dy,temp_x + temp_dx, temp_y + temp_dy);
      }
   
   
      public void travel() {
         x = x + dx;
         y = y + dy;
      
         direction = (direction + angular_velocity) & (255 | (Entity.TRIG_TAB_SIZEMO << 8));
      
         // if ((count & 3) == 0) {
         /*
            if (angular_velocity > 0) {
               angular_velocity = angular_velocity - angular_velocity << 2;
            }
            else
            {
               angular_velocity++;
            }
         	*/
      
         /*if ((count & 31) == 0) {
            angular_velocity = angular_velocity - angular_velocity << 5;
            if (length > 0) {
               length--;
            }
         }
      */
      
         // }
      
         count--;
      }
   
   
   }
