/*
 * Link Tyler 1998-1999.
 */

/*
 * ToDo
 *
 * Average out velocities...
 *
 */ 

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class Link extends Object {
      Entity entity1;
      Entity entity2;
   
      int preserved_x1;
      int preserved_y1;
      int preserved_x2;
      int preserved_y2;
   
      int upper_length_limit;
      int lower_length_limit;
      int upper_length_limit_squared;
      int lower_length_limit_squared;
   
      int breaking_length;
   
      int target_length;
   
      int elasticity;
      int friction;
      int status;
   
      int colour = 255;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static int actual_length;
      static int actual_length_squared;
      static int delta_x;
      static int delta_y;
      static int unit_vector_x;
      static int unit_vector_y;
      static int force_x;
      static int force_y;
   
      static int average_dx;
      static int average_dy;
   
      static int radius;
      static int diameter;
   
      static PrivateWorld temp_private_world;
   
      static boolean bleached = false;
   
      final static int MAX_DIAMETER = 16;
   
      final static int INVISIBLE = 0;
      final static int SOLID     = 1;
      final static int DOTTED    = 2;
      final static int CIRCLE    = 3;
      final static int BLEACHED  = 4;
      final static int POINT     = 5;
   
      final static int LONG = 0;
      final static int SHORT = 1;
   
      final static int DEAD            = 1 << 31;
      final static int SELECTED        = 1 << 25;
   
      final static int number_of_dots = 2;
      final static int log_number_of_dots = 1;
   
      static int link_display_type = SOLID;
      static int link_display_length = SHORT;
   
   // temp
      static int start_x;
      static int start_y;
      static int d_x;
      static int d_y;
   
      static int start_dx;
      static int start_dy;
      static int d_dx;
      static int d_dy;
   
   
      Link(Entity e1, Entity e2, int l, int e) {
         entity1 = e1;
         entity2 = e2;
         setInitialLength(l,l);
         elasticity = e;
         status = 0;
      }
   
   
      Link(Entity e1, Entity e2, int l, int e, int c, int s) {
         entity1 = e1;
         entity2 = e2;
         setInitialLength(l,l);
         elasticity = e;
         colour = c;
         status = s;
      }
   
   
      public void set(Entity e1, Entity e2, int l, int e) {
         entity1 = e1;
         entity2 = e2;
         setInitialLength(l,l);
         elasticity = e;
         status = 0;
      }
   
   
      public void set(Entity e1, Entity e2, int l, int e, int c, int s) {
         entity1 = e1;
         entity2 = e2;
         setInitialLength(l,l);
         elasticity = e;
         colour = c;
         status = s;
      }
   
   
   // DANGER
      public void set(Link l) {
         upper_length_limit = l.upper_length_limit;
         lower_length_limit = l.lower_length_limit;
      
         lower_length_limit_squared = l.lower_length_limit_squared;
         upper_length_limit_squared = l.upper_length_limit_squared;
      
         entity1 = l.entity1;
         entity2 = l.entity2;
      
         elasticity = l.elasticity;
         colour = l.colour;
         status = l.status;
      }
   
   
      public void setLength(int l) {
         upper_length_limit = l;
         lower_length_limit = l;
      
         lower_length_limit_squared = l * l;
         upper_length_limit_squared = l * l;
      
         // target_length = l;
      }
   
   
      public void setInitialLength(int i, int l) {
         upper_length_limit = i;
         lower_length_limit = i;
      
         lower_length_limit_squared = i * i;
         upper_length_limit_squared = i * i;
      
         target_length = l;
         breaking_length = 256; //l << 3; // l * 3...
      }
   
   
      public void setCurrentLength(int l) {
         upper_length_limit = l;
         lower_length_limit = l;
      
         lower_length_limit_squared = l * l;
         upper_length_limit_squared = l * l;
      }
   
   
      public void setElasticity(int e) {
         elasticity = e;
      }
   
   
      public void applyForce() {
         int delta_x;
         int delta_y;
         //int delta_z;
      
         int delta_dx;
         int delta_dy;
         //int delta_dz;
      
         int force_x;
         int force_y;
         //int force_z;
      
         int unit_vector_x;
         int unit_vector_y;
         //int unit_vector_z;
      
         int average_dx;
         int average_dy;
         //int average_dz;
      
         int parting;
      
         if (elasticity != 0) {
            delta_x = (entity1.x - entity2.x) >> Entity.shift;
            delta_y = (entity1.y - entity2.y) >> Entity.shift;
         
         
         
            // do cheaper checks first...?
            actual_length_squared = (delta_x * delta_x) + (delta_y * delta_y);
            if (actual_length_squared != lower_length_limit_squared) {
               actual_length = SquareRoot.sqrt(1 + actual_length_squared);
               delta_dx = (entity1.dx - entity2.dx);
               delta_dy = (entity1.dy - entity2.dy);
            
               parting = (delta_x * delta_dx) + (delta_y * delta_dy);
            
               unit_vector_x = (delta_x << Entity.shift) / actual_length;
               unit_vector_y = (delta_y << Entity.shift) / actual_length;
            
               if (actual_length_squared > upper_length_limit_squared) {
               
               // spring breaking?
                  if (actual_length > breaking_length) {
                     if ((entity1.status & Entity.HAS_INNER_WORLD) == 0) {
                        if ((entity2.status & Entity.HAS_INNER_WORLD) == 0) {
                           if (elasticity != 0) {
                              if (temp_private_world == Shoals.entity_manager) {
                              // debug("breaking");
                                 temp_private_world.creature_manager.killCreature(entity1);
                                 temp_private_world.creature_manager.killCreature(entity2);
                                 elasticity = 0;
                                 colour = 0;
                              }
                           }
                        }
                     }
                  }
               
                  // contract spring
                  force_x = (((unit_vector_x * (actual_length - upper_length_limit)) + 512) >> 10) * elasticity;
                  force_y = (((unit_vector_y * (actual_length - upper_length_limit)) + 512) >> 10) * elasticity;
               
                  if (parting < 0) {
                     force_x = force_x >> 1;
                     force_y = force_y >> 1;
                  }
               
                  entity1.dx -= force_x;
                  entity1.dy -= force_y;
               
                  entity2.dx += force_x;
                  entity2.dy += force_y;
               
               // internal damping...
               /*
                  average_dx = entity1.dx + entity2.dx + 8;
                  average_dy = entity1.dy + entity2.dy + 8;
               
                  entity1.dx = ((entity1.dx * 14) + average_dx) >> 4;
                  entity1.dy = ((entity1.dy * 14) + average_dy) >> 4;
               
                  entity2.dx = ((entity2.dx * 14) + average_dx) >> 4;
                  entity2.dy = ((entity2.dy * 14) + average_dy) >> 4;
               	*/
               
               /*
                  average_dx = entity1.dx + entity2.dx + 32;
                  average_dy = entity1.dy + entity2.dy + 32;
               
                  entity1.dx = ((entity1.dx * 62) + average_dx) >> 6;
                  entity1.dy = ((entity1.dy * 62) + average_dy) >> 6;
               
                  entity2.dx = ((entity2.dx * 62) + average_dx) >> 6;
                  entity2.dy = ((entity2.dy * 62) + average_dy) >> 6;
               	*/
               }
               else
               {
                  //if (actual_length_squared < lower_length_limit_squared) {
                  // expand spring
               
                  force_x = (((unit_vector_x * (lower_length_limit - actual_length)) + 512) >> 10) * elasticity;
                  force_y = (((unit_vector_y * (lower_length_limit - actual_length)) + 512) >> 10) * elasticity;
               
                  if (parting > 0) {
                     force_x = force_x >> 1;
                     force_y = force_y >> 1;
                  }
               
                  entity1.dx += force_x;
                  entity1.dy += force_y;
               
                  entity2.dx -= force_x;
                  entity2.dy -= force_y;
               
                  // internal damping...
                  /*
                  average_dx = entity1.dx + entity2.dx + 8;
                  average_dy = entity1.dy + entity2.dy + 8;
                  
                  entity1.dx = ((entity1.dx * 14) + average_dx) >> 4;
                  entity1.dy = ((entity1.dy * 14) + average_dy) >> 4;
                  
                  entity2.dx = ((entity2.dx * 14) + average_dx) >> 4;
                  entity2.dy = ((entity2.dy * 14) + average_dy) >> 4;
                  */
               
               /*
                  average_dx = entity1.dx + entity2.dx + 32;
                  average_dy = entity1.dy + entity2.dy + 32;
               
                  entity1.dx = ((entity1.dx * 62) + average_dx) >> 6;
                  entity1.dy = ((entity1.dy * 62) + average_dy) >> 6;
               
                  entity2.dx = ((entity2.dx * 62) + average_dx) >> 6;
                  entity2.dy = ((entity2.dy * 62) + average_dy) >> 6;
                  */
               }
            }
         
         // link dissolution...
            if (colour != 0) {
            
               if ((entity1.status & Entity.SPREADING_DEATH) != 0) {
                  colour = 79;
                  if ((entity1.status & Entity.DEATH_MASK) <= Entity.NO_LONGER_LATENT) {
                     if ((entity2.status & Entity.SPREADING_DEATH) == 0) { // new infection...
                        //if (((entity1.status | entity2.status) & Entity.HAS_INNER_WORLD) == 0) {
                        Entity.infectAlongALink(entity2, entity1);
                        //}
                     }
                  
                     if ((entity1.status & Entity.DEATH_MASK) <= Entity.BREAK_LINKS_NOW) {
                        if ((entity1.status & Entity.DEATH_MASK) == Entity.BREAK_LINKS_NOW) {
                           explodeThisLink();
                           elasticity = 0;
                        }
                     
                        colour = 0;
                     }
                     else
                     {
                        if ((entity1.status & Entity.DEATH_MASK) == Entity.NO_LONGER_LATENT) {
                           setLength(upper_length_limit + (upper_length_limit >> 4));
                           elasticity = elasticity >> 1;
                        }
                     }
                  }
               }
            
               if (colour != 0) {
                  if ((entity2.status & Entity.SPREADING_DEATH) != 0) {
                     colour = 79;
                     if ((entity2.status & Entity.DEATH_MASK) <= Entity.NO_LONGER_LATENT) {
                        if ((entity1.status & Entity.SPREADING_DEATH) == 0) { // new infection...
                           //if (((entity1.status | entity2.status) & Entity.HAS_INNER_WORLD) == 0) {
                           Entity.infectAlongALink(entity1, entity2);
                           //}
                        }
                     
                        if ((entity2.status & Entity.DEATH_MASK) <= Entity.BREAK_LINKS_NOW) {
                           if ((entity2.status & Entity.DEATH_MASK) == Entity.BREAK_LINKS_NOW) {
                              explodeThisLink();
                              elasticity = 0;
                           }
                        
                           colour = 0;
                        }
                        else
                        {
                           if ((entity2.status & Entity.DEATH_MASK) == Entity.NO_LONGER_LATENT) {
                              setLength(upper_length_limit + (upper_length_limit >> 4));
                              elasticity = elasticity >> 1;
                           }
                        }
                     }
                  }
               }
            }
            else // invisible link?  break it anyway...
            {
               // this processing can be cut down by a link status bit...
               if (elasticity != 0) { // ? questionable check...
                  if ((entity2.status & Entity.SPREADING_DEATH) != 0) {
                     if ((entity2.status & Entity.DEATH_MASK) < Entity.BREAK_LINKS_NOW) {
                        elasticity = 0;
                     }
                  }
               
                  if ((entity1.status & Entity.SPREADING_DEATH) != 0) {
                     if ((entity1.status & Entity.DEATH_MASK) <= Entity.BREAK_LINKS_NOW) {
                        elasticity = 0;
                     }
                  }
               }
            }
         }
      
         adjustLinkSize();
      }
   
   
      public void adjustLinkSize() {
         if ((Shoals_Grid.generation & 31) == 3) {
            if (upper_length_limit < target_length) {
               if ((target_length - upper_length_limit) >= 32) {
                  temp = (target_length - upper_length_limit) >> 4;
               }
               else
               {
                  temp = 1;
               }
            
               setCurrentLength(upper_length_limit + temp);
            }
            else
            {
               if (upper_length_limit > target_length) {
                  if ((upper_length_limit - target_length) >= 8) {
                     temp = (upper_length_limit - target_length) >> 2;
                  }
                  else
                  {
                     temp = 1;
                  }
               
                  setCurrentLength(upper_length_limit - temp);
               }
            }
         }
      }
   
   
      public void explodeThisLink() {
         // LinkManager.killSpecifiedLink(this); // danger Will Robinson...
      
         temp2 = SquareRoot.sqrt((d_x) * (d_x));
      
         start_x = preserved_x1 << Entity.shift;
         start_y = preserved_y1 << Entity.shift;
         d_x = preserved_x2 - preserved_x1;
         d_y = preserved_y2 - preserved_y1;
      
         temp2 = SquareRoot.sqrt(1 + (d_x * d_x) + (d_y * d_y));
      
         if (temp2 > 20) {
            temp2 = temp2 / 10;
         }
         else
         {
            temp2 = 4;
         }
      
         d_x = (d_x << Entity.shift) / temp2;
         d_y = (d_y << Entity.shift) / temp2;
      
         start_dx = entity1.dx;
         start_dy = entity1.dy;
      
         d_dx = (entity2.dx - entity1.dx) / temp2;
         d_dy = (entity2.dy - entity1.dy) / temp2;
      
         for (temp = 0; temp < temp2; temp++) {
            temp3 = rnd.nextInt();
            temp4 = (temp3 << 8) >> 23;
            temp3 = temp3 >> 23;
         
            LineFragmentManager.add(start_x, start_y, start_x + d_x, start_y + d_y, start_dx + temp3, start_dy + temp4, 4);
            start_x += d_x;
            start_y += d_y;
            start_dx += d_dx;
            start_dy += d_dy;
         }
      }
   
   
      public void draw() {
         if ((colour != 0) || bleached) {
         
            temp = bleached ? 511 : colour;
         
            if (Shoals_Grid.last_colour != temp) {
               Shoals_Grid.colour = temp;
               Shoals_Grid.quicklySetUpColour();
            }
         
            if (link_display_length == SHORT) {
               delta_x = (entity1.x - entity2.x) >> Entity.shift;
               delta_y = (entity1.y - entity2.y) >> Entity.shift;
            
               actual_length_squared = (delta_x * delta_x) + (delta_y * delta_y);
            
               actual_length = SquareRoot.sqrt(1 + actual_length_squared);
            
               unit_vector_x = (delta_x << Entity.shift) / actual_length;
               unit_vector_y = (delta_y << Entity.shift) / actual_length;
            
               preserved_x1 = (entity1.x - (unit_vector_x * entity1.radius)) >> Entity.shift;
               preserved_y1 = (entity1.y - (unit_vector_y * entity1.radius)) >> Entity.shift;
               preserved_x2 = (entity2.x + (unit_vector_x * entity2.radius)) >> Entity.shift;
               preserved_y2 = (entity2.y + (unit_vector_y * entity2.radius)) >> Entity.shift;
            }
            else
            {
               preserved_x1 = entity1.x >> Entity.shift;
               preserved_y1 = entity1.y >> Entity.shift;
               preserved_x2 = entity2.x >> Entity.shift;
               preserved_y2 = entity2.y >> Entity.shift;
            }
         
            switch (link_display_type) {
               case SOLID:
                  Shoals_Grid.graphics_handle.drawLine(preserved_x1,preserved_y1,preserved_x2,preserved_y2);
               
                  break;
            
               case CIRCLE:
                  diameter = (entity1.radius > entity2.radius) ? entity2.radius << 1 : entity1.radius << 1;
                  // diameter = (entity1.radius > entity2.radius) ? entity2.radius : entity1.radius;
                  diameter = (diameter > MAX_DIAMETER) ? MAX_DIAMETER : diameter;
                  radius = diameter >> 1;
               
                  switch (Shoals.quality) {
                     case Shoals._QUALITY_0:
                     case Shoals._QUALITY_1:
                     case Shoals._QUALITY_1A:
                        Shoals_Grid.graphics_handle.fillOval(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  
                     case Shoals._QUALITY_2:
                     case Shoals._QUALITY_2A:
                        Shoals_Grid.graphics_handle.drawOval(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  
                     case Shoals._QUALITY_3:
                     case Shoals._QUALITY_3A:
                        diameter >>= 1;
                        radius >>= 1;
                        Shoals_Grid.graphics_handle.drawRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                        break;
                  
                     case Shoals._QUALITY_4:
                     case Shoals._QUALITY_4A:
                        diameter >>= 1;
                        radius >>= 1;
                        Shoals_Grid.graphics_handle.fillRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  }
               
                  break;
            
               case DOTTED:
                  //temp2 = (preserved_x2 - preserved_x1) >> 3;
                  //temp3 = (preserved_y2 - preserved_y1) >> 3;
               
                  for (temp = 0; temp <= number_of_dots; temp++) {
                     Shoals_Grid.graphics_handle.fillRect(
                                             (preserved_x1 * temp) + (preserved_x2 * (number_of_dots - temp)) >> log_number_of_dots,
                                             (preserved_y1 * temp) + (preserved_y2 * (number_of_dots - temp)) >> log_number_of_dots,
                                          1,1);
                  }
               
                  break;
            
               case POINT:
                  Shoals_Grid.graphics_handle.fillRect(((preserved_x1 + preserved_x2) >> 1) - 1,((preserved_y1 + preserved_y2) >> 1) - 1,2,2);
               
                  break;
            }
         
            if ((status & SELECTED) != 0) {
               Shoals_Grid.colourRed();
               drawSelectedLink();
            }
         }
      }
   
   
      public void drawSelectedLink() {
         switch (link_display_type) {
            case CIRCLE:
               Shoals_Grid.graphics_handle.drawOval(((preserved_x1 + preserved_x2) >> 1) - 8,((preserved_y1 + preserved_y2) >> 1) - 8,16,16);
            
               break;
         
            default:
               d_x = (preserved_y1 - preserved_y2); // unit vector at right angles to line.
               d_y = (preserved_x2 - preserved_x1);
            
               start_dx = 1 + (SquareRoot.sqrt((d_x * d_x) + (d_y * d_y))); // pixels...
            
               d_x = (d_x << 3) / start_dx;
               d_y = (d_y << 3) / start_dx;
            
               Shoals_Grid.graphics_handle.drawLine(preserved_x1 + d_x,preserved_y1 + d_y, preserved_x2 + d_x, preserved_y2 + d_y);
               Shoals_Grid.graphics_handle.drawLine(preserved_x1 - d_x,preserved_y1 - d_y, preserved_x2 - d_x, preserved_y2 - d_y);
            
               d_x >>= 1;
               d_y >>= 1;
            
               Shoals_Grid.graphics_handle.drawLine(preserved_x1 + d_x,preserved_y1 + d_y, preserved_x2 + d_x, preserved_y2 + d_y);
               Shoals_Grid.graphics_handle.drawLine(preserved_x1 - d_x,preserved_y1 - d_y, preserved_x2 - d_x, preserved_y2 - d_y);
            
               break;
         }
      }
   
   
      public void scrub() {
         if ((colour != 0) || bleached) {
            switch (link_display_type) {
               case SOLID:
                  Shoals_Grid.colourZero();
               
                  Shoals_Grid.graphics_handle.drawLine(preserved_x1,preserved_y1,preserved_x2,preserved_y2);
               
                  break;
            
               case CIRCLE:
                  // diameter = entity1.radius + entity2.radius;
                  diameter = (entity1.radius > entity2.radius) ? entity2.radius << 1 : entity1.radius << 1;
                  diameter = (diameter > MAX_DIAMETER) ? MAX_DIAMETER : diameter;
                  radius = diameter >> 1;
               
                  switch (Shoals.quality) {
                     case Shoals._QUALITY_0:
                     case Shoals._QUALITY_1:
                        Shoals_Grid.colourZero();
                     
                        Shoals_Grid.graphics_handle.fillOval(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  
                     case Shoals._QUALITY_2:
                        Shoals_Grid.colourZero();
                     
                        //if (MAX_DIAMETER > diameter) {
                        // CRUDE HACK :-(
                        Shoals_Grid.graphics_handle.fillOval(((preserved_x1 + preserved_x2) >> 1) - radius - 1,((preserved_y1 + preserved_y2) >> 1) - radius - 1, diameter + 3, diameter + 3);
                        //}
                        //else
                        //{
                           //Shoals_Grid.graphics_handle.drawOval(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius, diameter, diameter);
                        //}
                     
                        break;
                  
                  
                     case Shoals._QUALITY_2A:
                        Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter + 1,diameter + 1);
                     
                        break;
                  
                     case Shoals._QUALITY_1A:
                        Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  
                  
                     case Shoals._QUALITY_3:
                     case Shoals._QUALITY_3A:
                        diameter >>= 1;
                        radius >>= 1;
                        Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter + 1,diameter + 1);
                     
                        break;
                  
                     case Shoals._QUALITY_4:
                     case Shoals._QUALITY_4A:
                        diameter >>= 1;
                        radius >>= 1;
                        Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - radius,((preserved_y1 + preserved_y2) >> 1) - radius,diameter,diameter);
                     
                        break;
                  }
               
                  break;
            
                  //Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - 4,((preserved_y1 + preserved_y2) >> 1) - 4,9,9);
            
                  //break;
            
               case DOTTED:
                  for (temp = 0; temp <= number_of_dots; temp++) {
                     Shoals_Grid.graphics_handle.clearRect(
                                             (preserved_x1 * temp) + (preserved_x2 * (number_of_dots - temp)) >> log_number_of_dots,
                                             (preserved_y1 * temp) + (preserved_y2 * (number_of_dots - temp)) >> log_number_of_dots,
                                          1,1);
                  }
               
                  break;
            
               case POINT:
                  Shoals_Grid.graphics_handle.clearRect(((preserved_x1 + preserved_x2) >> 1) - 1,((preserved_y1 + preserved_y2) >> 1) - 1,2,2);
               
                  break;
            }
         
            if ((status & SELECTED) != 0) {
               Shoals_Grid.colourZero();
               drawSelectedLink();
            }
         }
      }
   
   
      final public Entity theOtherEnd(Entity e) {
         if (entity1 == e) {
            return entity2;
         }
      
         return entity1;
      }
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
