/*
 * Shoals_Canvas Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.awt.image.*;

   public class Shoals_Canvas extends Canvas implements MouseListener, MouseMotionListener {
      static Image offScrImage;
   
      static Graphics image_handle;
   
      static ImageObserver observer;
   
      static Shoals parent;
      static int modifiers;
   
      static int xoff = 4;
      static int yoff = 4;
   
      static int img_x;
      static int img_y;
   
      static Dimension dim;
   
      static int x_pixels;
      static int y_pixels;
   
      static int gsx = 444;
      static int gsy = 444;
   
      static int gsx_old = -1;
      static int gsy_old = -1;
   
      static int old_gridsize = -99; 
      static int new_gridsize;
   
      static int current_mouse_x;
      static int current_mouse_y;
   
      // constructor
      Shoals_Canvas(Shoals mother) {
         parent = mother;
      
         addMouseMotionListener(this);
         addMouseListener(this);
      }
   
   
      // methods
      final public void start_up() {
         if (gsx < 1) 
            gsx = 511;
         if (gsy < 1) 
            gsy = 511;
      
         img_x = gsx; // (Shoals_Grid.hside) * (Shoals_Grid.gridsize);
         img_y = gsy; // (Shoals_Grid.vside) * (Shoals_Grid.gridsize);
      
         // System.out.println("hudfiehui : " + Shoals_Grid.gridsize);
      
         offScrImage = createImage(img_x, img_y); 
      
         getImageHandle();
      
         Shoals.entity_manager.resetEntityGrid(); // due to resize...
      
         Shoals_Grid.RepaintAll = true;
      }
   
   
      final public static void getImageHandle() {
         if (offScrImage != null) {
            image_handle = offScrImage.getGraphics();
         }
      }
   
   
      final public static void forceResize() {
         gsx_old = -1;
      }
   
   
   // draw
      final public void update(Graphics g) {
         observer = this;
      
         if (!Shoals_Grid.double_buffering) {
            image_handle = g;
            Shoals_Grid.redraw_changed(g); // image_handle);
            if (Shoals.current_message != 0)
               Shoals.handlemessages();
         }
      
         dim = getSize();
      
         x_pixels = dim.width;
         y_pixels = dim.height;
      
         gsx = x_pixels;
         gsy = y_pixels;
      
         if ((gsx != gsx_old) || (gsy != gsy_old)) {
            old_gridsize = new_gridsize;
         
            gsx_old = gsx;
            gsy_old = gsy;
         
            start_up();
         }
      
         xoff = 0; //(x_pixels >> 1) - ((Shoals_Grid.gridsize * Shoals_Grid.hside + (Shoals_Grid.gridsize >>> 1)) >>> 1);
         yoff = 0; // (y_pixels >> 1) - ((Shoals_Grid.gridsize * Shoals_Grid.vside + (Shoals_Grid.gridsize >>> 2)) >>> 1);
      
         if (Shoals_Grid.double_buffering) {
            if ((((Shoals_Grid.generation) & parent.frame_frequency) == 0) || (parent.paused)) {
               if (offScrImage != null) // needed due to some sort of bug (at Sun's end?)
                  g.drawImage(offScrImage,xoff,yoff,this);
            }
         }
      }
   
   
      final public void paint(Graphics g) {
         if (!Shoals_Grid.double_buffering) {
            Shoals_Grid.RepaintAll = true;
            Shoals_Grid.virgin_applet = 1; // not known why this hack is necessary :-(
         }
      
         update(g);
      }
   
   
   // mouse motion...
      public void mouseReleased(MouseEvent e) {
         parent.mouse_pressed = false;
         parent.newmessage(parent.MOUSE_RELEASE,e.getX() << Entity.shift,e.getY() << Entity.shift);
      }
   
      public void mousePressed(MouseEvent e) {
         modifiers = e.getModifiers();
         parent.mouse_pressed = true;
      
         parent.newmessage(parent.MOUSE_PRESSED,e.getX() << Entity.shift,e.getY() << Entity.shift);
      }
   
   
      public void mouseDragged(MouseEvent e) {
         modifiers = e.getModifiers();
         current_mouse_x = e.getX() << Entity.shift;
         current_mouse_y = e.getY() << Entity.shift;
      
         parent.newmessage(parent.MOUSE_DRAG,e.getX() << Entity.shift,e.getY() << Entity.shift);
      }
   
   
      public void mouseClicked(MouseEvent e) {
         modifiers = e.getModifiers();
      
         parent.newmessage(parent.MOUSE_CLICK,e.getX() << Entity.shift,e.getY() << Entity.shift);
      }
   
   
      public void mouseEntered(MouseEvent e) {
         parent.newmessage(parent.MOUSE_ENTRY,e.getX() << Entity.shift,e.getY() << Entity.shift);
      }
   
   
      public void mouseExited(MouseEvent e) {
      }
   
   
      public void mouseMoved(MouseEvent e) {
         parent.mouse_pressed = false;
      
         current_mouse_x = e.getX() << Entity.shift;
         current_mouse_y = e.getY() << Entity.shift;
      }
   
   }
