/*
 * Genome - Tim Tyler 2000-2000.
 */

   public class Genome extends Object {
      int[] genome;
   
      int genome_size;
      int max_genome_size;
      int genome_index;
      boolean executing;
   
      Entity initial_read_entity;
      Entity initial_write_entity;
   
   // not used...
      // Link initial_read_link;
      // Link initial_write_link;
   
      // static variables...
      static int[] new_genome;
      static int temp;
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      final static int COPY            = 0;
      final static int FOLLOW          = 1; // any active points go along current link...
      final static int READ_FOLLOW     = 2; // any active read points go along current link...
      final static int WRITE_FOLLOW    = 3; // any active write points go along current link...
      final static int READ_NEXT_LINK  = 4; // link number incremented (cyclicly)...
      final static int WRITE_NEXT_LINK = 5; // link number incremented (cyclicly)...
      final static int DELETE          = 6; // deletes link...
   
      final static int WAIT            = 997;
      final static int NULL            = 998;
      final static int FINISH          = 999; // creature done...
   
   
      Genome() {
         max_genome_size = 1;	
         genome = new int[max_genome_size];
      
         reset();
      }
   
   
      final void reset() {
         genome_size = 0;
         genome_index = 0;
         executing = false;
      
         initial_read_entity = null;
         initial_write_entity = null;
      	//initial_read_link = null;
         //initial_write_link = null;
      }
   
   
      final void add(int data) {
         if (genome_size >= max_genome_size) {
            makeMoreGenome();
         }
      
         genome[genome_size++] = data;
      }
   
   
      final void copy(Genome g) {
         reset();
      
         //initial_read_entity = g.initial_read_entity;
         //initial_write_entity = g.initial_write_entity;
      
         for (temp = 0; temp < g.genome_size; temp++) {
            add(g.genome[temp]);
         }
      }
   
   
     // again, this is wasteful :-|
      final void makeMoreGenome() {
         max_genome_size++;
      
         new_genome = new int[max_genome_size];
      
         for (temp = 0; temp < (max_genome_size - 1); temp++) {
            new_genome[temp] = genome[temp];
         }
      
         genome = new_genome;
      }
   
   
      final void finishExecution() {
         executing = false;
         genome_index = 0;
      }
   
   
   /*
     // returns number within this creature...
      final int getEntityNumber(Entity e) {
         for (temp = 0; temp < number_of_entities; temp++) {
            if (genome[temp] == e) {
               return temp;
            }
         }
      
         // debug("Entity is not part of this creature"); 
      
         return -1;
      }
   */
   
   
      final void debug(String o) {
      
         System.out.println(o);
      }
   }
